/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT
 * Although most of the following code is written from scratch, it is
 * heavily influenced by Q (https://github.com/kriskowal/q) and uses some of Q's spec.
 */
define(["require","exports","../Types","../Threading/deferImmediate","../Disposable/DisposableBase","../Exceptions/InvalidOperationException","../Exceptions/ArgumentException","../Exceptions/ArgumentNullException","../Disposable/ObjectPool","../Collections/Set","../Threading/defer","../Disposable/ObjectDisposedException","../../extends"],function(t,e,n,r,i,o,s,u,l,a,c,f,h){"use strict";function p(t){return n["default"].hasMemberOfType(t,S,n["default"].FUNCTION)}function d(t,e,n){var r=e?e(t):t;return r&&p(r)?C.wrap(r):n(r)}function v(t,e,n){try{var r=n?n(e):e;t&&t.resolve(r)}catch(i){t.reject(i)}}function w(t,e,n,r){try{var i=r?r(n):n;t&&t(i)}catch(o){e&&e(o)}}function y(t,e,n){t instanceof E?t.thenThis(e,n):t.then(e,n)}function g(t,e,n){return t instanceof E?t.thenSynchronous(e,n):t.then(e,n)}function _(){return new f.ObjectDisposedException("Promise","An underlying promise-result was disposed.")}var m=h["default"],b=void 0,j="Promise",I=j+"State",S="then",D="target",P=function(t){function e(e,n,r){t.call(this),this._state=e,this._result=n,this._error=r,this._disposableObjectName=I}return m(e,t),e.prototype._onDispose=function(){this._state=b,this._result=b,this._error=b},e.prototype.getState=function(){return this._state},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isPending",{get:function(){return this.getState()===C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isSettled",{get:function(){return this.getState()!=C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isFulfilled",{get:function(){return this.getState()===C.State.Fulfilled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRejected",{get:function(){return this.getState()===C.State.Rejected},enumerable:!0,configurable:!0}),e.prototype.getResult=function(){return this._result},Object.defineProperty(e.prototype,"result",{get:function(){return this.throwIfDisposed(),this.getResult()},enumerable:!0,configurable:!0}),e.prototype.getError=function(){return this._error},Object.defineProperty(e.prototype,"error",{get:function(){return this.throwIfDisposed(),this.getError()},enumerable:!0,configurable:!0}),e}(i.DisposableBase);e.PromiseState=P;var E=function(t){function e(){t.call(this,C.State.Pending),this._disposableObjectName=j}return m(e,t),e.prototype.then=function(t,e){var n=this;return new C(function(r,i){n.thenThis(function(e){return w(r,i,e,t)},function(t){return e?w(r,null,t,e):i(t)})})},e.prototype.done=function(t,e){var n=this;c.defer(function(){return n.thenThis(t,e)})},e.prototype.delayFromNow=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),new C(function(n,r){c.defer(function(){e.thenThis(function(t){return n(t)},function(t){return r(t)})},t)},!0)},e.prototype.delayAfterResolve=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),this.isSettled?this.delayFromNow(t):new C(function(n,r){e.thenThis(function(e){return c.defer(function(){return n(e)},t)},function(e){return c.defer(function(){return r(e)},t)})},!0)},e.prototype["catch"]=function(t){return this.throwIfDisposed(),this.then(b,t)},e.prototype["finally"]=function(t){return this.throwIfDisposed(),this.then(t,t)},e.prototype.finallyThis=function(t,e){this.throwIfDisposed();var n=e?n:function(){return r.deferImmediate(t)};return this.thenThis(n,n),this},e}(P);e.PromiseBase=E;var x=function(t){function e(){t.apply(this,arguments)}return m(e,t),e.prototype.thenSynchronous=function(t,e){this.throwIfDisposed();try{switch(this.state){case C.State.Fulfilled:return t?d(this._result,t,C.resolve):this;case C.State.Rejected:return e?d(this._error,e,C.resolve):this}}catch(n){return new R(n)}throw new Error("Invalid state for a resolved promise.")},e.prototype.thenThis=function(t,e){switch(this.throwIfDisposed(),this.state){case C.State.Fulfilled:t&&t(this._result);break;case C.State.Rejected:e&&e(this._error)}return this},e}(E);e.Resolvable=x;var A=function(t){function e(e,n,r){t.call(this),this._result=n,this._error=r,this._state=e}return m(e,t),e}(x);e.Resolved=A;var O=function(t){function e(e){t.call(this,C.State.Fulfilled,e)}return m(e,t),e}(A);e.Fulfilled=O;var R=function(t){function e(e){t.call(this,C.State.Rejected,b,e)}return m(e,t),e}(A);e.Rejected=R;var F=function(t){function e(e){var n=this;if(t.call(this),this._target=e,!e)throw new u.ArgumentNullException(D);if(!p(e))throw new s.ArgumentException(D,"Must be a promise-like object.");e.then(function(t){n._state=C.State.Fulfilled,n._result=t,n._error=b,n._target=b},function(t){n._state=C.State.Rejected,n._error=t,n._target=b})}return m(e,t),e.prototype.thenSynchronous=function(e,n){this.throwIfDisposed();var r=this._target;return r?new C(function(t,i){y(r,function(n){return w(t,i,n,e)},function(e){return n?w(t,null,e,n):i(e)})},!0):t.prototype.thenSynchronous.call(this,e,n)},e.prototype.thenThis=function(e,n){this.throwIfDisposed();var r=this._target;return r?(y(r,e,n),this):t.prototype.thenThis.call(this,e,n)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._target=b},e}(x),C=function(t){function e(e,n){void 0===n&&(n=!1),t.call(this),e&&this.resolveUsing(e,n)}return m(e,t),e.prototype.thenSynchronous=function(n,r){if(this.throwIfDisposed(),this._state)return t.prototype.thenSynchronous.call(this,n,r);var i=new e;return(this._waiting||(this._waiting=[])).push(k.PromiseCallbacks.init(n,r,i)),i},e.prototype.thenThis=function(e,n){return this.throwIfDisposed(),this._state?t.prototype.thenThis.call(this,e,n):((this._waiting||(this._waiting=[])).push(k.PromiseCallbacks.init(e,n)),this)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._resolvedCalled=b},e.prototype.resolveUsing=function(t,n,i){var s=this;if(void 0===n&&(n=!1),void 0===i&&(i=!1),!t)throw new u.ArgumentNullException("resolver");if(this._resolvedCalled)throw new o.InvalidOperationException(".resolve() already called.");if(this.state)throw new o.InvalidOperationException("Already resolved: "+e.State[this.state]);this._resolvedCalled=!0;var l=0,a=function(t){l?console.warn(-1==l?"Rejection called multiple times":"Rejection called after fulfilled."):(l=-1,s._resolvedCalled=!1,s.reject(t))},c=function(t){l?console.warn(1==l?"Fulfill called multiple times":"Fulfill called after rejection."):(l=1,s._resolvedCalled=!1,s.resolve(t))};n?t(c,a):r.deferImmediate(function(){return t(c,a)})},e.prototype._emitDisposalRejection=function(t){var e=t.wasDisposed;return e&&this._rejectInternal(_()),e},e.prototype._resolveInternal=function(t){var n=this;if(!this.wasDisposed){for(;t instanceof E;){var r=t;if(this._emitDisposalRejection(r))return;switch(r.state){case e.State.Pending:return void r.thenSynchronous(function(t){return n._resolveInternal(t)},function(t){return n._rejectInternal(t)});case e.State.Rejected:return void this._rejectInternal(r.error);case e.State.Fulfilled:t=r.result}}if(p(t))t.then(function(t){return n._resolveInternal(t)},function(t){return n._rejectInternal(t)});else{this._state=e.State.Fulfilled,this._result=t,this._error=b;var i=this._waiting;if(i){this._waiting=b;for(var o=0,s=i;o<s.length;o++){var u=s[o],l=u.onFulfilled,a=u.promise,c=a;k.PromiseCallbacks.recycle(u),v(c,t,l)}i.length=0}}}},e.prototype._rejectInternal=function(t){if(!this.wasDisposed){this._state=e.State.Rejected,this._error=t;var n=this._waiting;if(n){this._waiting=null;for(var r=0,i=n;r<i.length;r++){var o=i[r],s=o.onRejected,u=o.promise,l=u;k.PromiseCallbacks.recycle(o),s?v(l,t,s):l.reject(t)}n.length=0}}},e.prototype.resolve=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),t==this)throw new o.InvalidOperationException("Cannot resolve a promise as itself.");if(this._state){if(!n||this._state==e.State.Fulfilled&&this._result===t)return;throw new o.InvalidOperationException("Changing the fulfilled state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new o.InvalidOperationException(".resolve() already called.")}else this._resolveInternal(t)},e.prototype.reject=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),this._state){if(!n||this._state==e.State.Rejected&&this._error===t)return;throw new o.InvalidOperationException("Changing the rejected state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new o.InvalidOperationException(".resolve() already called.")}else this._rejectInternal(t)},e}(x);e.Promise=C;var T=function(t){function e(){t.apply(this,arguments)}return m(e,t),e.prototype.map=function(t){var n=this;return this.throwIfDisposed(),new e(function(e){n.thenThis(function(n){return e(n.map(t))})},!0)},e.prototype.reduce=function(t,e){return this.thenSynchronous(function(n){return n.reduce(t,e)})},e}(C);e.ArrayPromise=T;var N=function(t){function e(e){t.call(this),this._source=e&&e.slice()||[]}return m(e,t),e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._source.length=0,this._source=null},Object.defineProperty(e.prototype,"promises",{get:function(){return this.throwIfDisposed(),this._source.slice()},enumerable:!0,configurable:!0}),e.prototype.all=function(){return this.throwIfDisposed(),C.all(this._source)},e.prototype.race=function(){return this.throwIfDisposed(),C.race(this._source)},e.prototype.waitAll=function(){return this.throwIfDisposed(),C.waitAll(this._source)},e.prototype.map=function(t){var e=this;return this.throwIfDisposed(),new T(function(n){e.all().thenThis(function(e){return n(e.map(t))})},!0)},e.prototype.pipe=function(t){return this.throwIfDisposed(),new e(this._source.map(function(e){return g(e,t)}))},e.prototype.reduce=function(t,e){return this.throwIfDisposed(),C.wrap(this._source.reduce(function(e,n,r,i){return g(e,function(e){return g(n,function(n){return t(e,n,r,i)})})},p(e)?e:new O(e)))},e}(i.DisposableBase);e.PromiseCollection=N;var k;!function(t){var e;!function(t){function e(){return o||(o=new l.ObjectPool(40,n,function(t){t.onFulfilled=null,t.onRejected=null,t.promise=null}))}function n(){return{onFulfilled:null,onRejected:null,promise:null}}function r(t,n,r){var i=e().take();return i.onFulfilled=t,i.onRejected=n,i.promise=r,i}function i(t){e().add(t)}var o;t.init=r,t.recycle=i}(e=t.PromiseCallbacks||(t.PromiseCallbacks={}))}(k||(k={}));var C;!function(t){function e(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new u.ArgumentNullException("promises");return new N((Array.isArray(t)?t:[t]).concat(e))}function n(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new u.ArgumentNullException("promises");var r=(Array.isArray(t)?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new T(function(t){return t(r)},!0):new T(function(t,e){var n=[],i=r.length;n.length=i;for(var o=new a.Set(r.map(function(t,e){return e})),s=function(){e=null,t=null,r.length=0,r=null,o.dispose(),o=null},u=function(){var e=t;e&&!o.count&&(s(),e(n))},l=function(e,r){t&&(n[r]=e,o.remove(r),u())},c=function(t){var n=e;n&&(s(),n(t))},f=function(t){var e=r[t];e?e.then(function(e){return l(e,t)},c):o.remove(t),u()},h=0;o&&i>h;h++)f(h)})}function r(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new u.ArgumentNullException("promises");var r=(Array.isArray(t)?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new T(function(t){return t(r)},!0):new T(function(t,e){for(var n=r.length,i=new a.Set(r.map(function(t,e){return e})),o=function(){e=null,t=null,i.dispose(),i=null},s=function(){var e=t;e&&!i.count&&(o(),e(r))},u=function(t){i&&(i.remove(t),s())},l=function(t){var e=r[t];e?e.then(function(e){return u(t)},function(e){return u(t)}):u(t)},c=0;i&&n>c;c++)l(c)})}function i(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];var i=e&&(Array.isArray(e)?e:[e]).concat(n);if(!i||!i.length||!(i=i.filter(function(t){return null!=t})).length)throw new s.ArgumentException("Nothing to wait for.");var o=i.length;if(1==o)return c(i[0]);for(var u=0;o>u;u++){var l=i[u];if(l instanceof E&&l.isSettled)return l}return new t(function(t,e){for(var n=function(){e=null,t=null,i.length=0,i=null},r=function(t,e){t&&(n(),t(e))},o=function(e){return r(t,e)},s=function(t){return r(e,t)},u=0,l=i;u<l.length;u++){var a=l[u];if(!t)break;a.then(o,s)}})}function o(t){return p(t)?c(t):new O(t)}function l(t){return new R(t)}function c(t){if(!t)throw new u.ArgumentNullException(D);return p(t)?t instanceof E?t:new F(t):new O(t)}function f(t){if(!t)throw new u.ArgumentNullException(S);return new F({then:t})}!function(t){t[t.Pending=0]="Pending",t[t.Fulfilled=1]="Fulfilled",t[t.Rejected=-1]="Rejected"}(t.State||(t.State={}));var h=t.State;Object.freeze(h),t.group=e,t.all=n,t.waitAll=r,t.race=i,t.resolve=o,t.reject=l,t.wrap=c,t.createFrom=f}(C=e.Promise||(e.Promise={})),Object.defineProperty(e,"__esModule",{value:!0}),e["default"]=C});
//# sourceMappingURL=Promise.js.map
